import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { Ad_material } from '../models/index' 

import {Ad_meterial_detailMU} from './Ad_meterial_detail' 


/**
 * @author auto generate
 * @version 1.0
 * @date 2021-04-19 14:25
 */
interface Ad_materialCU extends ConditionUtil<Ad_materialCU>{
    ID:FieldUtil<Ad_materialCU>;
    AD_STYLE_ID:FieldUtil<Ad_materialCU>;
    NAME:FieldUtil<Ad_materialCU>;
    STATUS:FieldUtil<Ad_materialCU>;
    CREATE_TIME:FieldUtil<Ad_materialCU>;
    CREATOR:FieldUtil<Ad_materialCU>;
    UPDATE_TIME:FieldUtil<Ad_materialCU>;
    UPDATOR:FieldUtil<Ad_materialCU>;
}

class Ad_materialCUImpl extends ConditionUtilImpl<Ad_materialCUImpl> implements Ad_materialCU{ 
    newInstance(): Ad_materialCUImpl {
        return new Ad_materialCUImpl();
    } 
    get ID(): FieldUtil<Ad_materialCU>{  
        return new FieldUtil('ID','id','素材id', this);
    }
    get AD_STYLE_ID(): FieldUtil<Ad_materialCU>{  
        return new FieldUtil('AD_STYLE_ID','adStyleId','广告样式id', this);
    }
    get NAME(): FieldUtil<Ad_materialCU>{  
        return new FieldUtil('NAME','name','素材名称', this);
    }
    get STATUS(): FieldUtil<Ad_materialCU>{  
        return new FieldUtil('STATUS','status','状态：0，启用；1，删除', this);
    }
    get CREATE_TIME(): FieldUtil<Ad_materialCU>{  
        return new FieldUtil('CREATE_TIME','createTime','', this);
    }
    get CREATOR(): FieldUtil<Ad_materialCU>{  
        return new FieldUtil('CREATOR','creator','', this);
    }
    get UPDATE_TIME(): FieldUtil<Ad_materialCU>{  
        return new FieldUtil('UPDATE_TIME','updateTime','', this);
    }
    get UPDATOR(): FieldUtil<Ad_materialCU>{  
        return new FieldUtil('UPDATOR','updator','', this);
    }
}

@Singleton 
class Ad_materialMU extends TableUtilImpl<Ad_materialCU,Ad_material>{ 
    tableName  = 'ad_material';
    tableFields  = ['id','ad_style_id','name','status','create_time','creator','update_time','updator'];
    modelFields  = ['id','adStyleId','name','status','createTime','creator','updateTime','updator'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [{
            name: 'ad_meterial_detail',
            parentIdFields: [Ad_materialMU.ID],
            foreignKeyFields: [Ad_meterial_detailMU.AD_MATERIAL_ID],
            getTableUtil: ()=>{
                return Container.get(Ad_meterial_detailMU);
            }
        } as SubTable

];

    createConditionUtil(): Ad_materialCU {
        return new Ad_materialCUImpl();
    }   

    static get ID(): FieldUtil<Ad_materialCU>{ 
        return new FieldUtil('ID','id','素材id', new Ad_materialCUImpl());
    }
    static get AD_STYLE_ID(): FieldUtil<Ad_materialCU>{ 
        return new FieldUtil('AD_STYLE_ID','adStyleId','广告样式id', new Ad_materialCUImpl());
    }
    static get NAME(): FieldUtil<Ad_materialCU>{ 
        return new FieldUtil('NAME','name','素材名称', new Ad_materialCUImpl());
    }
    static get STATUS(): FieldUtil<Ad_materialCU>{ 
        return new FieldUtil('STATUS','status','状态：0，启用；1，删除', new Ad_materialCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<Ad_materialCU>{ 
        return new FieldUtil('CREATE_TIME','createTime','', new Ad_materialCUImpl());
    }
    static get CREATOR(): FieldUtil<Ad_materialCU>{ 
        return new FieldUtil('CREATOR','creator','', new Ad_materialCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<Ad_materialCU>{ 
        return new FieldUtil('UPDATE_TIME','updateTime','', new Ad_materialCUImpl());
    }
    static get UPDATOR(): FieldUtil<Ad_materialCU>{ 
        return new FieldUtil('UPDATOR','updator','', new Ad_materialCUImpl());
    }

    get ID(): FieldUtil<Ad_materialCU>{ 
        return Ad_materialMU.ID;
    }
    get AD_STYLE_ID(): FieldUtil<Ad_materialCU>{ 
        return Ad_materialMU.AD_STYLE_ID;
    }
    get NAME(): FieldUtil<Ad_materialCU>{ 
        return Ad_materialMU.NAME;
    }
    get STATUS(): FieldUtil<Ad_materialCU>{ 
        return Ad_materialMU.STATUS;
    }
    get CREATE_TIME(): FieldUtil<Ad_materialCU>{ 
        return Ad_materialMU.CREATE_TIME;
    }
    get CREATOR(): FieldUtil<Ad_materialCU>{ 
        return Ad_materialMU.CREATOR;
    }
    get UPDATE_TIME(): FieldUtil<Ad_materialCU>{ 
        return Ad_materialMU.UPDATE_TIME;
    }
    get UPDATOR(): FieldUtil<Ad_materialCU>{ 
        return Ad_materialMU.UPDATOR;
    }
}
export {Ad_materialMU, Ad_materialCU}
